/*
 * Copyright (c) 2019 University of Colorado
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Author: Derek Hageman <Derek.Hageman@noaa.gov>
 */
#ifndef CPD3GRAPHINGDISPLAY_H
#define CPD3GRAPHINGDISPLAY_H

#include "core/first.hxx"

#include <memory>
#include <QtGlobal>
#include <QObject>
#include <QRectF>
#include <QSizeF>
#include <QSize>
#include <QList>
#include <QString>
#include <QVariant>
#include <QPaintDevice>
#include <QPainter>
#include <QMouseEvent>
#include <QKeyEvent>
#include <QSettings>
#include <QUndoCommand>
#include <QAction>
#include <QWidget>
#include <QMenu>

#include "graphing/graphing.hxx"
#include "datacore/processingtapchain.hxx"
#include "datacore/variant/root.hxx"
#include "datacore/segment.hxx"
#include "core/number.hxx"
#include "core/textsubstitution.hxx"

namespace CPD3 {
namespace Graphing {

/**
 * A coupling control for a display.  Displays can have components of them
 * coupled to other displays to ensure they have the same basic layout.  This
 * is normally used for the axes of graphs.
 */
class CPD3GRAPHING_EXPORT DisplayCoupling : public QObject {
Q_OBJECT
public:
    /**
     * The mode the layout engine will try to couple copmonents.
     */
    enum CoupleMode {
        /**
         * Try to couple components if they are on the same horizontal 
         * level.
         */
        SameRow, /**
         * Try to couple components if they are on the same vertical level.
         */
        SameColumn, /**
         * Always try to couple components on the same layout.
         */
        Always,
    };

    DisplayCoupling();

    DisplayCoupling(CoupleMode mode);

    virtual ~DisplayCoupling();

    /**
     * Test if component can coupled with another.
     * 
     * @param other     the potential combination target
     * @return          true if the two axes can be coupled
     */
    virtual bool canCouple(const std::shared_ptr<DisplayCoupling> &other) const = 0;

    /**
     * Combine the data of the components into a value suitable for passing
     * to applyCoupling(const QVariant &). 
     * 
     * @param components    the components to combine
     * @return              the combined data
     */
    virtual QVariant combine(const std::vector<
            std::shared_ptr<DisplayCoupling>> &components) const = 0;

    /**
     * The position on the layout this component occupies, relative to
     * the ones it was coupled with.
     */
    enum CouplingPosition {
        /** The first (left/topmost) of the coupled components. */
        First, /** A middle component. */
        Middle, /** The last (right/bottommost) of the coupled components. */
        Last, /** The only (first and last) of the components. */
        Only,
    };

    /**
     * Apply coupling to the origin of this component.  The data is 
     * generated by the call to combine(const QList<std::shared_ptr<DisplayCoupling> > &).  
     * 
     * @param data      the data to set
     * @param position  the position of the component
     */
    virtual void applyCoupling(const QVariant &data, CouplingPosition position = Middle) = 0;

    /**
     * Get the coupling mode.
     * 
     * @return the coupling mode
     */
    CoupleMode getMode() const;

private:
    CoupleMode coupleMode;
};

/**
 * A coupling component with default implementations to handle data ranges.
 */
class CPD3GRAPHING_EXPORT DisplayRangeCoupling : public DisplayCoupling {
Q_OBJECT
public:
    DisplayRangeCoupling();

    DisplayRangeCoupling(DisplayCoupling::CoupleMode mode);

    virtual ~DisplayRangeCoupling();

    /**
     * This implementation calls getMin() and getMax() on each component
     * and returns a list variant with the range (min and max) extended as
     * much as possible.
     * 
     * @see DisplayCoupling(const std::vector<std::shared_ptr<DisplayCoupling> > &)
     */
    virtual QVariant combine(const std::vector<std::shared_ptr<DisplayCoupling>> &components) const;

    virtual double getMin() const = 0;

    virtual double getMax() const = 0;
};

/**
 * A single displayable output.  This is used to do things like enabling and
 * disabling traces via a right click menu.
 */
class CPD3GRAPHING_EXPORT DisplayOutput : public QWidget {
Q_OBJECT
public:
    virtual ~DisplayOutput();

    DisplayOutput();

    /**
     * Get the "title" of this output.  For example, the text in the legend.
     * 
     * @return the output title
     */
    virtual QString getTitle() const = 0;

    /**
     * Get a list of actions that could be inserted into a menu to control
     * the output.
     * <br>
     * The default implementation returns nothing.
     * 
     * @return  a list of newly allocated actions
     */
    virtual QList<QAction *> getMenuActions(QWidget *parent = 0);

signals:

    /**
     * Emitted whenever part of the output has changed.
     */
    void changed();
};

/**
 * An interface that defines the zoom for a display.
 */
class CPD3GRAPHING_EXPORT DisplayZoomAxis : public QObject {
Q_OBJECT
public:
    virtual ~DisplayZoomAxis();

    DisplayZoomAxis();

    /**
     * Get the title of axis.  This is what is displayed in a zoom dialog.
     * 
     * @return the axis title
     */
    virtual QString getTitle() const = 0;

    /**
     * Get the current (possibly zoomed) minimum of the axis.
     * 
     * @return the minimum of the axis, or FP::undefined() if it has no data
     */
    virtual double getMin() const = 0;

    /**
     * Get the current (possibly zoomed) maximum of the axis.
     * 
     * @return the maximum of the axis, or FP::undefined() if it has no data
     */
    virtual double getMax() const = 0;

    /**
     * Get the current zoomed minimum of the axis.  This is used to properly
     * undo zooms, since the axis may have bounds but not be zoomed.
     * 
     * @return the zoomed axis minimum, or FP::undefined() if it is not zoomed
     */
    virtual double getZoomMin() const = 0;

    /**
     * Get the current zoomed maximum of the axis.  This is used to properly
     * undo zooms, since the axis may have bounds but not be zoomed.
     * 
     * @return the zoomed axis maximum, or FP::undefined() if it is not zoomed
     */
    virtual double getZoomMax() const = 0;

    /** The mode that the values of the axis are displayed for. */
    enum DisplayMode {
        /** Automatic selection. */
        Display_Automatic, /** Decimal ("9.99"). */
        Display_Decimal, /** Exponential ("9.99E9"). */
        Display_Exponential, /** Display as a time range. */
        Display_Time,
    };

    /**
     * Get the mode that the axis should be displayed as.
     * <br>
     * The default implementation returns Display_Automatic.
     * 
     * @return the display mode
     */
    virtual DisplayMode getDisplayMode() const;

    /**
     * Get the set of other axes this one is coupled with.  For example left
     * and right axes are coupled together even if they have defferent units.
     * <br>
     * The default implementation returns nothing.
     * 
     * @return a list of coupled axes
     */
    virtual std::vector<std::shared_ptr<DisplayZoomAxis>> getCoupledAxes() const;

    /**
     * Set the zoom of this axis.
     * 
     * @param min   the new minimum or FP::undefined() to clear
     * @param max   the new maximum or FP::undefined() to clear
     */
    virtual void setZoom(double min, double max) = 0;

    /**
     * Test if this axis shares a zoom with the other one.  This is used to
     * apply global zooms, for example.
     * <br>
     * The default implementation returns false.
     * 
     * @param other the other axis to test
     * @return      true if this axis zooms with the other one
     */
    virtual bool sharedZoom(const std::shared_ptr<DisplayZoomAxis> &other) const;
};

/**
 * A class that warps display zoom axes operations into an undoable
 * command.
 */
class CPD3GRAPHING_EXPORT DisplayZoomCommand : public QUndoCommand {
public:
    class CPD3GRAPHING_EXPORT Axis {
    private:
        std::shared_ptr<DisplayZoomAxis> axis;
        double beforeMin;
        double beforeMax;
        double afterMin;
        double afterMax;
    public:
        Axis();

        Axis(const Axis &other);

        Axis &operator=(const Axis &other);

        Axis(Axis &&other);

        Axis &operator=(Axis &&other);

        Axis(std::shared_ptr<DisplayZoomAxis> to, double min, double max);

        Axis(std::shared_ptr<DisplayZoomAxis> to, const Axis &other);

        void undo();

        void redo();

        QString getTitle() const;

        inline bool sharedZoom(const std::shared_ptr<DisplayZoomAxis> &other) const
        { return axis->sharedZoom(other); }
    };

    DisplayZoomCommand();

    DisplayZoomCommand(const DisplayZoomCommand &other);

    DisplayZoomCommand &operator=(const DisplayZoomCommand &other);

    DisplayZoomCommand(DisplayZoomCommand &&other);

    DisplayZoomCommand &operator=(DisplayZoomCommand &&other);

    explicit DisplayZoomCommand(std::vector<Axis> set);

    /**
     * Add an axis to the command.
     * @param axis the axis to add
     */
    void add(const Axis &axis);

    /**
     * Add an axis to the command.
     * @param axis  the axis to add
     * @param min   the zoom minimum
     * @param max   the zoom maximum
     */
    void add(const std::shared_ptr<DisplayZoomAxis> &axis, double min, double max);

    /**
     * Potentially add a combining axis to the command.  This will not add
     * the axis if it does not share with an existing one.  The range added
     * is the range of the first one it shares with.
     * 
     * @param axis  the axis to add
     */
    void addCombining(const std::shared_ptr<DisplayZoomAxis> &axis);

    /**
     * Append the other zoom command to this one.  The result will be that
     * this zoom command applies the other command as well.
     * 
     * @param other the command to add
     */
    void append(const DisplayZoomCommand &other);

    void redo() override;

    void undo() override;

    bool isValid() const;

private:
    std::vector<Axis> axes;

    void updateText();
};

/**
 * A highlighting controller for the graph.
 */
class CPD3GRAPHING_EXPORT DisplayHighlightController : public QObject {
Q_OBJECT
public:
    virtual ~DisplayHighlightController();

    DisplayHighlightController();

    /**
     * Clear all highlights.
     */
    virtual void clear() = 0;

    /**
     * Describes the origin of a specific highlighted range.
     */
    enum HighlightType {
        /** Generic or unknown origin. */
        Generic, /** From a mentor edit. */
        MentorEdit, /** From an event log entry. */
        EventLog,
    };

    /**
     * Add a new highlighted range.
     * 
     * @param type      the type of this lighlight
     * @param start     the start time of the highlight or undefined for -infinity
     * @param end       the end time of the highlight or undefined for +infinity
     * @param min       the minimum value of the highlight or undefined for -infinity
     * @param max       the maximum value time of the highlight or undefined for +infinity
     * @param selection the selection of variables the highlight applies to
     */
    virtual void add(HighlightType type,
                     double start,
                     double end,
                     double min = FP::undefined(),
                     double max = FP::undefined(),
                     const Data::SequenceMatch::Composite &selection = Data::SequenceMatch::Composite(
                             Data::SequenceMatch::Element::SpecialMatch::All)) = 0;
};

/**
 * An interface for a layout engine to interact with modifiable components
 * of the display.  This is usually used as part of a right click editing
 * menu.
 */
class CPD3GRAPHING_EXPORT DisplayModificationComponent : public QWidget {
Q_OBJECT
public:
    virtual ~DisplayModificationComponent();

    DisplayModificationComponent();

    /**
     * Get the "title" of this output.  For example, the text in the legend.
     * 
     * @return the output title
     */
    virtual QString getTitle() const = 0;

    /**
     * Get a list of actions that could be inserted into a menu to control
     * the modifier.
     * <br>
     * The default implementation returns nothing.
     * 
     * @return  a list of newly allocated actions
     */
    virtual QList<QAction *> getMenuActions(QWidget *parent = 0);

signals:

    /**
     * Emitted whenever part of the modification component has changed.
     */
    void changed();
};

/**
 * An interface to get default values from.
 */
class CPD3GRAPHING_EXPORT DisplayDefaults {
    Data::SequenceName::Component registerStation;
    Data::SequenceName::Component registerArchive;
    Data::SequenceName::Component archiveRT;
    QSettings *settings;
public:
    DisplayDefaults();

    DisplayDefaults(const DisplayDefaults &other);

    DisplayDefaults &operator=(const DisplayDefaults &other);

    DisplayDefaults(DisplayDefaults &&other);

    DisplayDefaults &operator=(DisplayDefaults &&other);

    /**
     * Construct a variable selection from the given configuration and
     * any defaults that need to be applied.
     * 
     * @param config        the input configuration
     * @param asRealtime    true if the trace is for realtime data
     * @return              a variable selection
     */
    Data::SequenceMatch::Composite constructSequenceMatch(const Data::Variant::Read &config,
                                                          bool asRealtime = false) const;

    /**
     * Get a global settings object reference.  If this returns non-NULL then
     * the settings object must remain valid for the lifetime of all displays
     * constructed with the defaults.
     * 
     * @return      a settings object pointer or NULL
     */
    QSettings *getSettings() const;

    /**
     * Set the global settings object reference.  If this is set to non-NULL
     * then the settings object must remain valid for the lifetime of all
     * displays constructed with the defaults.
     * 
     * @param settings  the settings to use
     */
    void setSettings(QSettings *settings);

    /**
     * Set the default station.
     *
     * @param station   the station
     */
    void setStation(const Data::SequenceName::Component &station);

    /**
     * Set the default archive.
     *
     * @param archvie   the archive
     */
    void setArchive(const Data::SequenceName::Component &archive);

    /**
     * Set the realtime archive.
     *
     * @param archive   the realtime archive
     */
    void setArchiveRealtime(const Data::SequenceName::Component &archive);
};

/**
 * A context object defining the dynamic parts of a display.  This includes
 * things like handling text substitutions in "static" (e.x. a graph title)
 * parts of the display. 
 */
class CPD3GRAPHING_EXPORT DisplayDynamicContext {
public:
    /** The context the static string is used in. */
    enum StringContext {
        /** A general/unknown string. */
        String_General,

        /** A string in the legend. */
        String_GraphLegend,

        /** A string in the graph title. */
        String_GraphTitle,

        /** A string in the title of an axis in a graph. */
        String_GraphAxesTitle,
    };
private:
    class SubstitutionHandler : public TextSubstitution {
        const DisplayDynamicContext *context;
        StringContext type;
        bool *changed;
    public:

        SubstitutionHandler(const DisplayDynamicContext *context,
                            StringContext type,
                            bool *changed);

        virtual ~SubstitutionHandler();

    protected:
        /**
         * Get the string to replace the given variable key with.
         *
         * @param key       the input key
         * @return          the replacement
         */
        virtual QString substitution(const QStringList &elements) const;

        QString applyTimeFormat(double time, const QStringList &elements) const;
    };

    bool interactive;
    QString station;
    QSettings *settings;

public:
    DisplayDynamicContext();

    DisplayDynamicContext(const DisplayDynamicContext &other);

    DisplayDynamicContext &operator=(const DisplayDynamicContext &other);

    DisplayDynamicContext(DisplayDynamicContext &&other);

    DisplayDynamicContext &operator=(DisplayDynamicContext &&other);

    /**
     * Set the interactive status of this context.
     * 
     * @param b true if the context is interactive and deferrable.
     */
    inline void setInteractive(bool b)
    { interactive = b; }

    /**
     * If set then the operation is interactive and can be deferred until later 
     * if needed.  This is used for long running screen paints (e.x. fitting a 
     * model).  If an operation is deferred the display should emit 
     * Display::deferredPaintUpdated() when it might be completed (but it
     * may not be ready entirely at that stage).
     * 
     * @return true if the operation is interactive and deferrable
     */
    inline bool getInteractive() const
    { return interactive; }

    /**
     * Set the station substitution.
     * 
     * @param stn   the station substitution
     */
    inline void setStation(const QString &stn)
    { station = stn.toUpper(); }

    inline void setStation(const CPD3::Data::SequenceName::Component &stn)
    { setStation(QString::fromStdString(stn)); }


    /**
     * Get a global settings object reference.  If this returns non-NULL then
     * the settings object must remain valid for the lifetime of all displays
     * using the context.
     * 
     * @return      a settings object pointer or NULL
     */
    inline QSettings *getSettings() const
    { return settings; }

    /**
     * Set the global settings object reference.  If this is set to non-NULL
     * then the settings object must remain valid for the lifetime of all
     * displays using the context.
     * 
     * @param set   the settings to use
     */
    inline void setSettings(QSettings *set)
    { settings = set; }

    /**
     * Perform string substitution for a static string.  This does
     * not need to be performed any elements that cannot have dynamic
     * parts (e.x. the auto-generated trace names).
     * 
     * @param str       the input/output string
     * @param context   the context of the string
     * @param changed   if not NULL then will be set to true if this string contained something flagged as changed, otherwise ignored
     * @return          the modified string
     */
    QString &handleString(QString &str,
                          StringContext context = String_General,
                          bool *changed = NULL) const;

    /**
     * @see handleString( QString &, StringContext, bool * ) const;
     * @param str       the input/output string
     * @param context   the context of the string
     * @param changed   if not NULL then will be set to true if this string contained something flagged as changed, otherwise ignored
     * @return          the modified string
     */
    inline QString handleString(const QString &str,
                                StringContext context = String_General,
                                bool *changed = NULL) const
    {
        QString mod(str);
        return handleString(mod, context, changed);
    }
};

class TraceDispatch;

class Display;

class DisplaySaveContext;

/**
 * A class that controls the overriding of components of a trace
 * dispatch.
 */
class CPD3GRAPHING_EXPORT TraceDispatchOverride {
    Data::Variant::Root smoothing;

    friend class DisplaySaveContext;

    TraceDispatchOverride(const Data::Variant::Read &sm);

public:
    TraceDispatchOverride();

    TraceDispatchOverride(const TraceDispatchOverride &other);

    TraceDispatchOverride &operator=(const TraceDispatchOverride &other);

    TraceDispatchOverride(TraceDispatchOverride &&other);

    TraceDispatchOverride &operator=(TraceDispatchOverride &&other);

    Data::ValueSegment::Transfer get(const TraceDispatch *dispatch) const;
};

/**
 * The context for saving the current override state of a display.  This
 * provides the target Value as well as information about what should be
 * saved.
 */
class CPD3GRAPHING_EXPORT DisplaySaveContext {
    Data::ValueSegment::Transfer target;
    QHash<const Display *, TraceDispatchOverride> tdo;
public:
    DisplaySaveContext();

    DisplaySaveContext(const DisplaySaveContext &other);

    DisplaySaveContext &operator=(const DisplaySaveContext &other);

    DisplaySaveContext(DisplaySaveContext &&);

    DisplaySaveContext &operator=(DisplaySaveContext &&);

    void overlay(const Data::Variant::Read &value);

    void underlay(const Data::Variant::Read &value);

    void overlay(const Data::Variant::Read &value, const QString &path);

    void underlay(const Data::Variant::Read &value, const QString &path);

    void overlay(const Data::ValueSegment::Transfer &over);

    void underlay(const Data::ValueSegment::Transfer &under);

    void overlay(const Data::ValueSegment::Transfer &over, const QString &path);

    void underlay(const Data::ValueSegment::Transfer &under, const QString &path);

    TraceDispatchOverride traceDispatchOverride(const Display *display);

    void setTraceDispatchSmoothing(const Display *display, const Data::Variant::Read &smoothing);

    /**
     * Get the result of the save operation.
     * 
     * @return the result
     */
    inline const Data::ValueSegment::Transfer &result() const
    { return target; }

    /**
     * Get a single value representing the save operation.
     * @return a simplified version of the save.
     */
    inline Data::Variant::Read singleResult() const
    {
        if (target.empty()) return Data::Variant::Read::empty();
        return target.back().read();
    }
};


/**
 * The main interface from which all displays are derived.
 */
class CPD3GRAPHING_EXPORT Display : public QObject {
Q_OBJECT
public:
    Display(const DisplayDefaults &defaults = DisplayDefaults(), QObject *parent = 0);

    Display(const Display &other);

    virtual ~Display();

    /**
     * Create a copy of the display.  The new display will NOT share the
     * painting state nor any of the related components.
     * 
     * @return a copy of the display
     */
    virtual std::unique_ptr<Display> clone() const = 0;

    static QColor parseColor(const Data::Variant::Read &value,
                             const QColor &defaultColor = QColor());

    static Data::Variant::Root formatColor(const QColor &color);

    static QFont parseFont(const Data::Variant::Read &value, const QFont &defaultFont = QFont());

    static Data::Variant::Root formatFont(const QFont &font);

    static Qt::PenStyle parsePenStyle(const Data::Variant::Read &value,
                                      Qt::PenStyle defaultStyle = Qt::SolidLine);

    static Data::Variant::Root formatPenStyle(Qt::PenStyle style);

    static QMenu *selectPenStyle(Qt::PenStyle style,
                                 const std::function<void(Qt::PenStyle)> &set,
                                 QWidget *parent = nullptr);

    /**
     * Register any inputs needed for this display in the given filter chain.
     * The caller can sub-class the chain to provide exit smoothing.
     * <br>
     * The default implementation does nothing.
     * 
     * @param chain         the chain to get data from
     */
    virtual void registerChain(Data::ProcessingTapChain *chain);

    /**
     * Get all display outputs.  These may update with time.  Each is a 
     * discrete "output" of the display, for example each trace on a graph
     * is an output.
     * <br>
     * The default implementation returns nothing.
     * 
     * @param context   the display context
     * @return          a list of display elements
     */
    virtual std::vector<
            std::shared_ptr<DisplayOutput>> getOutputs(const DisplayDynamicContext &context = {});

    /**
     * Get all data coupling elements for this display.  Data elements are
     * coupled after prepare but before predict.
     * <br>
     * The default implementation returns nothing.
     * 
     * @return          a list of coupling items
     */
    virtual std::vector<std::shared_ptr<DisplayCoupling>> getDataCoupling();

    /**
     * Get all layout coupling elements for this display.  Layout elements are
     * coupled after predict but before paint.
     * <br>
     * The default implementation returns nothing.
     * 
     * @return          a list of coupling items
     */
    virtual std::vector<std::shared_ptr<DisplayCoupling>> getLayoutCoupling();

    /**
     * Get the requested minimum size of the display.  This will only be called
     * after prediction.
     * <br>
     * The default implementation returns zero.
     * 
     * @param paintdevice           the device that drawing will be done it, if available
     * @param context               the dynamic context
     */
    virtual QSizeF getMinimumSize(QPaintDevice *paintdevice = nullptr,
                                  const DisplayDynamicContext &context = {});

    /**
     * Prepare the display for rendering.  This is called before any
     * coupling is fetched.  An example usage is for a graph to determine
     * the minimum and maximum ranges of its axes.  This is optional and may
     * not be called before painting.
     * <br>
     * The default implementation does nothing.
     * 
     * @param maximumDimensions     the maximum possible dimensions the display might occupy
     * @param paintdevice           the device that drawing will be done it, if available
     * @param context               the dynamic context
     */
    virtual void prepareLayout(const QRectF &maximumDimensions,
                               QPaintDevice *paintdevice = nullptr,
                               const DisplayDynamicContext &context = {});

    /**
     * Called to allow the display to predict its layout if needed.  This is
     * called after data coupling but before layout coupling.  An example use
     * is for a graph to predict the size of its axes.  This is optional,
     * that is, it may not be called before the actual paint.
     * <br>
     * The default implementation does nothing.
     * 
     * @param maximumDimensions     the maximum possible dimensions the display might occupy
     * @param paintdevice           the device that drawing will be done it, if available
     * @param context               the dynamic context
     */
    virtual void predictLayout(const QRectF &maximumDimensions,
                               QPaintDevice *paintdevice = nullptr,
                               const DisplayDynamicContext &context = {});

    /**
     * Draw the display within the given dimensions.
     * 
     * @param painter       the painter to draw with
     * @param dimensions    the dimensions to draw within
     * @param context       the dynamic context
     */
    virtual void paint(QPainter *painter,
                       const QRectF &dimensions,
                       const DisplayDynamicContext &context = {}) = 0;

    /**
     * Analog for QWidget::mousePressEvent(QMouseEvent*), the position
     * will be in drawing space.
     * @return true to consume the event
     */
    virtual bool eventMousePress(QMouseEvent *event);

    /**
     * Analog for QWidget::mouseReleaseEvent(QMouseEvent*), the position
     * will be in drawing space.
     * @return true to consume the event
     */
    virtual bool eventMouseRelease(QMouseEvent *event);

    /**
     * Analog for QWidget::mouseMoveEvent(QMouseEvent*), the position
     * will be in drawing space.  This will only be delivered if
     * tracking has been requested with setMouseTracking(bool).
     * @return true to consume the event
     */
    virtual bool eventMouseMove(QMouseEvent *event);

    /**
     * Analog for QWidget::keyPressEvent(QKeyEvent*).
     * @return true to consume the event
     */
    virtual bool eventKeyPress(QKeyEvent *event);

    /**
     * Analog for QWidget::keyReleaseEvent(QKeyEvent*).
     * @return true to consume the event
     */
    virtual bool eventKeyRelease(QKeyEvent *event);

    /**
     * Get the modification component at the given mouseover point, if any.
     * <br>
     * The default implementation returns nothing.
     * 
     * @param point         the point to edit, in painting space
     * @param dimensions    the dimensions, if any
     * @param context       the dynamic context
     * @return              the modification component, or NULL
     */
    virtual std::shared_ptr<DisplayModificationComponent> getMouseModification(const QPoint &point,
                                                                               const QRectF &dimensions = {},
                                                                               const DisplayDynamicContext &context = {});

    /**
     * Set the mouseover point to a given value.  This is only called if
     * acceptsMouseover() returns true.
     * <br>
     * The default implementation does nothing
     * 
     * @param point         the point to display, in painting space
     */
    virtual void setMouseover(const QPoint &point);

    /**
     * Get the zoom controller for the display, if any.
     * <br>
     * The default implementation returns NULL.
     * 
     * @return              a zoom controller or NULL
     */
    virtual std::vector<std::shared_ptr<DisplayZoomAxis>> zoomAxes();

    /**
     * Get the highlight controller for the display, if any.
     * <br>
     * The default implementation returns NULL.
     * 
     * @return              a highlight controller or NULL
     */
    virtual std::shared_ptr<DisplayHighlightController> highlightController();

    /**
     * Save any override changes to the given value.  Note that zooming does
     * not count as an override.
     * <br>
     * The default implementation does nothing
     * 
     * @param target        the target value
     * @param appendChain   the values (if any) to append to an existing filter chain
     */
    virtual void saveOverrides(DisplaySaveContext &target);

    /**
     * Test if the display accepts any keyboard input.  That is, if the
     * rendering parent should concern itself with widget focus.
     * <br>
     * The default implementation returns false.
     * 
     * @return true if the display accepts keyboard input
     */
    virtual bool acceptsKeyboardInput() const;

    /**
     * Test if the display accepts mouseover input.  That is, if 
     * setMouseover(const QPoint&) should be called.  Note that if this is
     * set, the Display will also receive eventMousePress( QMouseEvent *)
     * even if it has not requested mouse tracking (and mouse tracking
     * cannot be disabled).
     * <br>
     * The default implementation returns false.
     * 
     * @return true if the display accepts mouseover tracking
     */
    virtual bool acceptsMouseover() const;

public slots:

    /**
     * After calling all overrides set by the various modification interfaces
     * are reset and removed.  This includes resetting the zoom.
     * <br>
     * The default implementation does nothing.
     */
    virtual void resetOverrides();

    /**
     * Trims data to only show values within the given range.  Data may be
     * reloaded later if the visible range changes.
     * <br>
     * The default implementation does nothing.
     * 
     * @param the start of cached data
     * @param end the end of cached data
     */
    virtual void trimData(double start, double end);

    /**
     * Set the range of times that should be shown.  This may be less than
     * what was actual chain produces.
     * <br>
     * The default implementation does nothing.
     * 
     * @param start the start of visible data
     * @param end   the end of visible data
     */
    virtual void setVisibleTimeRange(double start, double end);

    /**
     * Called when interaction with the display has been stopped (manual 
     * escape, timeout, etc).  All grabs/tracking have been released.
     * <br>
     * The default implementation does nothing.
     */
    virtual void interactionStopped();

    /**
     * Clear the mouseover if any.
     * <br>
     * The default implementation does nothing.
     */
    virtual void clearMouseover();

signals:

    /**
     * Emitted when all input data has ended and the display is ready for
     * final rendering.
     */
    void readyForFinalPaint();

    /**
     * Emitted to request a repaint for interactive usage.
     * 
     * @param userInitiated true if the repaint comes from user interaction (e.x. mouse movement)
     */
    void interactiveRepaint(bool userInitiated = false);

    /**
     * Optionally emitted when the list of display outputs has changed.
     */
    void outputsChanged();

    /**
     * Emitted when a time range has been selected (but not zoomed to).  This
     * can be used by a display controller to dispatch the selection to a
     * mentor edit, for example.
     * 
     * @param start     the selected start time
     * @param end       the selected end time
     */
    void timeRangeSelected(double start, double end);

    /**
     * Emitted when a zoom is generated internally.  For example, this is
     * used by graphs when an area is selected by the mouse.  This provided
     * so the parent can implement an undo stack that handles zooming.  The
     * parent should call the command's redo() function when it receives
     * this.
     * 
     * @param command   the zoom command
     */
    void internalZoom(CPD3::Graphing::DisplayZoomCommand command);

    /**
     * Emitted to request mouse tracking to begin (that is, to receive position
     * events).
     * 
     * @param enable    true to enable mouse tracking
     */
    void setMouseTracking(bool enable);

    /**
     * Emitted to request mouse grab to begin.
     * 
     * @param enable    true to enable mouse grab
     */
    void setMouseGrab(bool enable);

    /**
     * Emitted to request keyboard grab to begin.
     * 
     * @param enable    true to enable keyboard grab
     */
    void setKeyboardGrab(bool enable);

    /**
     * Emitted to request a toolTip at the given point.
     * 
     * @param point the position in draw space
     * @param text  the text or empty to hide
     */
    void setToolTip(const QPoint &point, const QString &text);
};

}
}

#endif
